5 TW=0:TD=0:TH=0:TM=0:TS=0:TT=0:TIMER=0 ' Initialise the elapsed time variables
10 'initialise I/O pins
15 voltpin1 = 1 'set analog voltage input pin for main bus (can be 1 - 10)
20 voltpin2 = 2 'set analog voltage input pin for 9V rail (can be 1 - 10)
25 voltpin3 = 3 'set analog voltage input pin for 5V rail (can be 1 - 10)
30 pwmpin = 8 'set the pwm output pin (can be 7 - 10)
35 freqpin1 = 14 'set the frequency input pin (can be 11 - 14)
40 freq = 100 'set initial frequency to 100Hz (can be 1 - 5000)
45 duty = 50 'set initial duty cycle to 50% (can be 0 - 100 in increments of 1)
50 offset1 = 0 'use to adjust for any offset in analog input for main bus
55 offset2 = 0 'use to adjust for any offset in analog input for 9V rail
60 offset3 = 0 'use to adjust for any offset in analog input for 5V rail
65 coefficient1 = 20 'use to scale the analog input for main bus (range 0 - 66 (20 * 3.3))
70 coefficient2 = 5 'use to scale the analog input for 9V rail (range 0 - 16.5 (5 * 3.3))
75 coefficient3 = 3 'use to scale the analog input for 5V rail (range 0 - 9.9 (3 * 3.3))
80 tick_avg = 100 'number of analog voltage samples to average each second
85 tick_flag = 0
90 tick_cnt = 0
95 DIM tick_array1(tick_avg)
100 DIM tick_array2(tick_avg)
105 DIM tick_array3(tick_avg)
110 SETPIN voltpin3,1 'configure pin for analog input
115 SETPIN voltpin2,1 'configure pin for analog input
120 SETPIN voltpin1,1 'configure pin for analog input
125 SETPIN freqpin1,3 'configure pin for frequency input
130 SETPIN pwmpin,10,freq,duty 'initiate PWM output
135 SETTICK CINT(1000/tick_avg),1100 'set tick interrupt for tick_avg per second
140 'initialise print locations
145 locMainBuss = 12
150 loc9VRail = 36
155 loc5VRail = 60
160 locRepFreq = 84
165 locRunFreq = 108
170 locRunDuty = 132
175 locElapsed = 156
180 locCmdString = 180
185 locCmdInput = locCmdString + 12
190 duty_str$ = "Enter duty cycle (0 - 100 for 0% - 100%), 'F' to change frequency or 'Q' to quit"
195 freq_str$ = "Enter frequency (1 - 5000 for 1 - 5kHz), 'D' to change duty cycle or 'Q' to quit"
200 CLS
205 volt1 = offset1 + (PIN(voltpin1) * coefficient)
210 volt2 = offset2 + (PIN(voltpin2) * coefficient)
215 volt3 = offset3 + (PIN(voltpin3) * coefficient)
220 state = 1
225 LOCATE 0,locMainBuss : ? "Main Buss A V+ =";
230 LOCATE 96,locMainBuss : ? FORMAT$(volt1,"% .3fV ");
235 LOCATE 0,loc9VRail : ? "9 Volt Rail V+ =";
240 LOCATE 96,loc9VRail : ? FORMAT$(volt2,"% .3fV ");
245 LOCATE 0,loc5VRail : ? "5 Volt Rail V+ =";
250 LOCATE 96,loc5VRail : ? FORMAT$(volt3,"% .3fV ");
255 LOCATE 0,locRepFreq : ? "Reported frequency =";
260 LOCATE 120,locRepFreq : ? FORMAT$(PIN(freqpin1),"% .0fHz    ");
265 LOCATE 0,locRunFreq : ? "Running frequency =";
270 LOCATE 114,locRunFreq : ? freq; "Hz ";
275 LOCATE 0,locRunDuty : ? "Mark space ratio =";
280 LOCATE 108,locRunDuty : ? duty; "% ";
285 LOCATE 0,locElapsed:GOSUB 10000 ' This will print the elapsed time
290 LOCATE 0,locCmdString : ? duty_str$
295 DO WHILE state > 0
300  GOSUB 500
305  IF state = 1 THEN
310   IF number >= 0 AND number <= 100 THEN
315    duty = number : SETPIN pwmpin,10,freq,duty
320   ELSE
325    GOSUB 900 : ? number; " - Invalid duty cycle!" : PAUSE(1000) : GOSUB 900
330   ENDIF
335  ELSEIF state = 2 THEN
340   IF number >= 1 AND number <= 5000 THEN
345    freq = number : SETPIN pwmpin,10,freq,duty
350   ELSE
355    GOSUB 900 : ? number; " - Invalid frequency!" : PAUSE(1000) : GOSUB 900
360   ENDIF
365  ENDIF
370  LOCATE 96,locMainBuss : ? FORMAT$(volt1,"% .3fV ");
375  LOCATE 96,loc9VRail : ? FORMAT$(volt2,"% .3fV ")
380  LOCATE 96,loc5VRail : ? FORMAT$(volt3,"% .3fV ")
385  LOCATE 120,locRepFreq : ? FORMAT$(PIN(freqpin1),"% .0fHz    ");
390  LOCATE 114,locRunFreq : ? freq; "Hz ";
395  LOCATE 108,locRunDuty : ? duty; "% ";
400  LOCATE 0,locElapsed:GOSUB 10000 ' This will print the elapsed time
405 LOOP
410 SETPIN voltpin3,0
415 SETPIN voltpin2,0
420 SETPIN voltpin1,0
425 SETPIN freqpin1,0
430 SETPIN pwmpin,0
435 GOSUB 900
459 END
499 ' get number routine
500 GOSUB 900
505 DO WHILE 1
510  IF tick_flag = 1 THEN
515   tick_flag = 0
520   LOCATE 96,locMainBuss : ? FORMAT$(volt1,"% .3fV ");
525   LOCATE 96,loc9VRail : ? FORMAT$(volt2,"% .3fV ");
530   LOCATE 96,loc5VRail : ? FORMAT$(volt3,"% .3fV ");
535   LOCATE 120,locRepFreq : ? FORMAT$(PIN(freqpin1),"% .0fHz    ");
540   LOCATE 114,locRunFreq : ? freq; "Hz ";
545   LOCATE 108,locRunDuty : ? duty; "% ";
550   LOCATE 0,locElapsed:GOSUB 10000 ' This will print the elapsed time
555   LOCATE LEN(numstr$) * 6,locCmdInput
560  ENDIF
565  inpkey$ = UCASE$(INKEY$)
570  IF inpkey$ = "" THEN GOTO 510
575  IF inpkey$ = "Q" THEN state = -1 : EXIT
580  IF inpkey$ = "D" THEN
585   LOCATE 0,locCmdString
590   ? duty_str$
595   state = 1
600   GOSUB 900
605   GOTO 510
610  ENDIF
615  IF inpkey$ = "F" THEN
620   LOCATE 0,locCmdString
625   ? freq_str$
630   state = 2
635   GOSUB 900
640   GOTO 510
645  ENDIF
650  IF inpkey$ < "0" OR inpkey$ > "9" THEN
655   numlen = LEN(numstr$)
660   IF ASC(inpkey$) = 13 THEN
665    IF numlen = 0 THEN number = -1 ELSE number = VAL(numstr$)
670    EXIT
675   ELSEIF ASC(inpkey$) = 8 THEN
680    IF numlen > 0 THEN
685     IF numlen <> 1 THEN numstr$ = LEFT$(numstr$, numlen - 1) ELSE numstr$ = ""
690     csr = (numlen - 1) * 6
695     LOCATE csr,locCmdInput : ? " "; : LOCATE csr,locCmdInput
700    ENDIF
705   ENDIF
710  ELSE
715   numstr$ = numstr$ + inpkey$
720   ? inpkey$;
725  ENDIF
730 LOOP
735 GOSUB 900
799 RETURN
899 ' clear input
900 numstr$ = ""
910 LOCATE 0,locCmdInput
920 ? SPACE$(80)
930 LOCATE 0,locCmdInput
999 RETURN
1099 ' settick interrupt routine
1100 tick_cnt = tick_cnt + 1
1110 tick_array1(tick_cnt) = offset1 + (PIN(voltpin1) * coefficient1)
1120 tick_array2(tick_cnt) = offset2 + (PIN(voltpin2) * coefficient2)
1130 tick_array3(tick_cnt) = offset3 + (PIN(voltpin3) * coefficient3)
1140 IF tick_cnt <> tick_avg THEN IRETURN
1150 volt1 = 0
1160 volt2 = 0
1170 volt3 = 0
1180 FOR i = 1 TO tick_avg
1190  volt1 = volt1 + tick_array1(i)
1200  volt2 = volt2 + tick_array2(i)
1210  volt3 = volt3 + tick_array3(i)
1220 NEXT i
1230 volt1 = volt1 / tick_avg
1240 volt2 = volt2 / tick_avg
1250 volt3 = volt3 / tick_avg
1260 tick_cnt = 0
1270 tick_flag = 1
1299 IRETURN
9999 ' Elapsed time routine to update the elapsed time and print it
10000 TC=TIMER:TIMER=0:TT=TT+TC
10010 IF TT>=1000 THEN TS=TS+(TT\1000):TT=TT MOD 1000
10020 IF TS>=60 THEN TM=TM+(TS\60):TS=TS MOD 60
10030 IF TM>=60 THEN TH=TH+(TM\60):TM=TM MOD 60
10040 IF TH>=24 THEN TD=TD+(TH\24):TH=TH MOD 24
10050 IF TD>=7 THEN TW=TW+(TD\7):TD=TD MOD 7
10060 pflag=0:? "Elapsed time:";
10070 IF TW>0 THEN pflag=1:? TW;" weeks,";
10080 IF TD>0 OR pflag=1 THEN pflag=1:? TD;" days,";
10090 IF TH>0 OR pflag=1 THEN pflag=1:? TH;" hours,";
10100 IF TM>0 OR pflag=1 THEN ? TM;" minutes,";
10110 ? FORMAT$(TS," %1.0f.");FORMAT$(TT,"%03.0f seconds ");
10120 RETURN
